%define debug_package %{nil}

%global version 5.10.0
%global tarballpath 5.10
%global fileversion 5.10.0.871

Name:		monodevelop
Version:	%{version}
Release:	%mkrel 16
Summary:        A full-featured IDE for Mono and Gtk#
Group:		Development/Other
License:        GPLv2+
URL:            http://monodevelop.com/
Source0:        http://download.mono-project.com/sources/monodevelop/monodevelop-%{fileversion}.tar.bz2
# Fedora patches:
Patch0:         monodevelop-avoidgiterrors.patch
Patch1:         monodevelop-downgrade_to_mvc3.patch
Patch2:         monodevelop-nuget-unbundle.patch
Patch3:         monodevelop-no-nuget-packages.patch
BuildRequires:  pkgconfig(mono) >= 3.0.4
BuildRequires:  pkgconfig(mono-addins) >= 0.6
BuildRequires:  pkgconfig(nunit2) >= 2.6.3
BuildRequires:  pkgconfig(monodoc)
BuildRequires:	pkgconfig(glade-sharp-2.0)
BuildRequires:	pkgconfig(gnome-sharp-2.0)
BuildRequires:	desktop-file-utils
BuildRequires:	intltool
BuildRequires:  pkgconfig(nuget-core)
BuildRequires:  pkgconfig(libssh2)
BuildRequires:  newtonsoft-json
BuildRequires:  cmake
BuildRequires:  git
Requires:       mono-core >= 3.0.4
Requires:       mono-addins >= 0.6
# Using system nunit, but dependency not automatically picked up by RPM
Requires:       mono(nunit.core)
Requires:       mono(nunit.framework)
Requires:       mono-locale-extras
Requires:	subversion monodoc
Requires:       hicolor-icon-theme shared-mime-info
Requires:       gtk-sharp2
Requires:	gnome-sharp2
Requires:	git
Requires:	xsp


%description
This package provides MonoDevelop, a full-featured IDE for Mono with
syntax coloring, code completion, debugging, project management and
support for C sharp, Visual Basic.NET, Java, Boo, Nemerle and MSIL.


%package        devel
Summary:        Development files for monodevelop
Group:		Development/Other
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig
Requires:       newtonsoft-json
Conflicts:      monodevelop <= 5.10.0-5.mga6

%description devel
Development files for %{name}.


%prep
%setup -qn %{name}-%{tarballpath}
%autopatch -p1

for f in tests/TestRunner/TestRunner.csproj tests/UserInterfaceTests/UserInterfaceTests.csproj src/addins/NUnit/NUnitRunner/NUnitRunner.csproj src/addins/NUnit/MonoDevelop.NUnit.csproj external/nrefactory/ICSharpCode.NRefactory.Tests/ICSharpCode.NRefactory.Tests.csproj
do
  echo $f
  sed -i "s#<HintPath>.*nunit\..*</HintPath>##g" $f
done

sed -i "s#<HintPath>.*Newtonsoft\.Json\.dll</HintPath>#<Package>newtonsoft-json</Package><Private>True</Private>#g" tests/UserInterfaceTests/UserInterfaceTests.csproj

# Delete shipped *.dll files
find -name '*.dll' -exec rm -f {} \;

#Fixes for Mono 4
sed -i "s#gmcs#mcs#g; s#dmcs#mcs#g" configure
sed -i "s#gmcs#mcs#g; s#dmcs#mcs#g" configure.in
sed -i "s#mono-nunit#nunit#g" configure.in
find . -name "*.sln" -print -exec sed -i 's/Format Version 10.00/Format Version 11.00/g' {} \;
find . -name "*.csproj" -print -exec sed -i 's#ToolsVersion="3.5"#ToolsVersion="4.0"#g; s#<TargetFrameworkVersion>.*</TargetFrameworkVersion>##g; s#<PropertyGroup>#<PropertyGroup><TargetFrameworkVersion>v4.5</TargetFrameworkVersion>#g' {} \;

# reference newtonsoft-json properly
sed -i "s#-r:\${libdir}/bin/Newtonsoft.Json.dll#-r:/usr/lib/mono/newtonsoft-json/Newtonsoft.Json.dll#g" monodevelop.pc.in

%build
%configure --enable-git --disable-update-mimedb --disable-update-desktopdb

cd ./external/libgit2sharp/Lib/CustomBuildTasks
xbuild CustomBuildTasks.csproj
mv bin/Debug/* .
cd ../../../../

make

%check
make check

%install
%make_install

mkdir -p $RPM_BUILD_ROOT/%{_prefix}/lib/monodevelop/AddIns/NUnit
ln -s ../../../mono/nunit2/nunit.core.dll $RPM_BUILD_ROOT/%{_prefix}/lib/monodevelop/AddIns/NUnit
ln -s ../../../mono/nunit2/nunit.core.interfaces.dll $RPM_BUILD_ROOT/%{_prefix}/lib/monodevelop/AddIns/NUnit
ln -s ../../../mono/nunit2/nunit.framework.dll $RPM_BUILD_ROOT/%{_prefix}/lib/monodevelop/AddIns/NUnit
ln -s ../../../mono/nunit2/nunit.util.dll $RPM_BUILD_ROOT/%{_prefix}/lib/monodevelop/AddIns/NUnit

desktop-file-install \
                     --dir $RPM_BUILD_ROOT%{_datadir}/applications \
                     --delete-original \
  $RPM_BUILD_ROOT%{_datadir}/applications/monodevelop.desktop

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
test "%{_libdir}" = "%{_prefix}/lib" || mv $RPM_BUILD_ROOT/%{_prefix}/lib/pkgconfig/* $RPM_BUILD_ROOT/%{_libdir}/pkgconfig

# already installed in %{_datadir}/locale ?
rm -rf %{buildroot}%{_prefix}/lib/monodevelop/locale

# Register as an application to be visible in the software center
#
# NOTE: It would be *awesome* if this file was maintained by the upstream
# project, translated and installed into the right place during `make install`.
#
# See http://www.freedesktop.org/software/appstream/docs/ for more details.
#
mkdir -p $RPM_BUILD_ROOT%{_datadir}/appdata
cat > $RPM_BUILD_ROOT%{_datadir}/appdata/%{name}.appdata.xml <<EOF
<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright 2014 Richard Hughes <richard@hughsie.com> -->
<!--
BugReportURL: https://bugzilla.xamarin.com/show_bug.cgi?id=23288
SentUpstream: 2014-09-23
-->
<application>
  <id type="desktop">monodevelop.desktop</id>
  <metadata_license>CC0-1.0</metadata_license>
  <description>
    <p>
      MonoDevelop is a cross-platform IDE primarily designed for C# and other
      .NET languages.
      MonoDevelop enables developers to quickly write desktop and ASP.NET Web
      applications on Linux, Windows and Mac OSX.
    </p>
    <p>
      MonoDevelop makes it easy for developers to port .NET applications created
      with Visual Studio to Linux and Mac OSX maintaining a single code base for
      all platforms.
    </p>
  </description>
  <url type="homepage">http://monodevelop.com/</url>
  <screenshots>
    <screenshot type="default">https://raw.githubusercontent.com/hughsie/fedora-appstream/master/screenshots-extra/monodevelop/a.png</screenshot>
  </screenshots>
  <!-- FIXME: change this to an upstream email address for spec updates
  <updatecontact>someone_who_cares@upstream_project.org</updatecontact>
   -->
</application>
EOF

%find_lang %{name}

%files -f %{name}.lang
%doc AUTHORS ChangeLog COPYING README
%{_bindir}/m*
%{_prefix}/lib/monodevelop
%{_mandir}/man1/m*
%{_datadir}/appdata/*.appdata.xml
%{_datadir}/applications/*.desktop
%{_datadir}/icons/hicolor/*/*/*
%{_datadir}/mime/packages/monodevelop.xml

%files devel
%{_libdir}/pkgconfig/monodevelop*.pc


%changelog
* Wed Sep 23 2020 tv <tv> 5.10.0-16.mga8
+ Revision: 1629623
- Add an AppData file for the software center

* Mon Sep 21 2020 tv <tv> 5.10.0-15.mga8
+ Revision: 1629098
- rebuild for new mono

* Sun Feb 16 2020 umeabot <umeabot> 5.10.0-14.mga8
+ Revision: 1536129
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Mon Oct 14 2019 daviddavid <daviddavid> 5.10.0-13.mga8
+ Revision: 1453212
- switch to mono-nunit2

* Wed Feb 20 2019 wally <wally> 5.10.0-12.mga7
+ Revision: 1368945
- require newtonsoft-json with devel pkg
- drop requires on devel pkgs
- sync .spec a bit with Fedora
- build without gnome-desktop-sharp

* Sun Sep 23 2018 umeabot <umeabot> 5.10.0-11.mga7
+ Revision: 1299594
- Mageia 7 Mass Rebuild

* Fri Sep 08 2017 cjw <cjw> 5.10.0-10.mga7
+ Revision: 1152003
- rebuild for openssl 1.1
- disable debug packages

* Tue Apr 12 2016 daviddavid <daviddavid> 5.10.0-9.mga6
+ Revision: 1000836
- add a patch to remove reference of Newtonsoft.Json.dll in monodevelop.pc file
  o comes from recent unbundled newtonsoft-json
  o thus fixing build for other monodevelop packages

* Fri Apr 08 2016 tv <tv> 5.10.0-8.mga6
+ Revision: 999387
- rebuild for new newtonsoft-json

* Fri Apr 08 2016 tv <tv> 5.10.0-7.mga6
+ Revision: 999351
- drop requires on mono-devel
- requires gnome-desktop-sharp
- requires hicolor-icon-theme
- drop requires on mono-basic & xterm
- drop useless BRs
- drop old requires rexclude
- drop old obsoletes
- partial sync of rquires with FC
- drop unused sources
- add %%check section
- use std macro for installing
- split devel subpackage
- package COPYING too

* Fri Apr 08 2016 tv <tv> 5.10.0-6.mga6
+ Revision: 999296
- fix build by building the FC way
- add more mono4 fixes from FC
+ umeabot <umeabot>
- Rebuild for openssl

* Sun Jan 03 2016 neoclust <neoclust> 5.10.0-5.mga6
+ Revision: 919284
- Rebuild without the workaround

* Sun Jan 03 2016 neoclust <neoclust> 5.10.0-4.mga6
+ Revision: 919266
- Rebuild against current workaround
+ anaselli <anaselli>
- requires mono-devel not libmono-devel

* Sat Jan 02 2016 matteo <matteo> 5.10.0-2.mga6
+ Revision: 918564
- fixing build tasks issues
- drop nuget packages
- add missing br cmake
+ tv <tv>
- new release
- one more patch from FC
- one more fix from FC
- use pkgconfig() style for BR on nuget
- // make seems to work
- add more patches from FC
- use system nuget
- drop unapplied patches
- use system nuit
- mono4 fixes from FC
- fix BR
- revert
- temporary remove BR on nunit
- rebuild for mono4
+ anaselli <anaselli>
- new version

* Sun Feb 22 2015 matteo <matteo> 5.7.0-1.mga5
+ Revision: 816587
- fixed version and release
- new version 5.7.0.660

* Wed Oct 15 2014 umeabot <umeabot> 5.0.1-3.mga5
+ Revision: 750611
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 5.0.1-2.mga5
+ Revision: 682586
- Mageia 5 Mass Rebuild
+ tv <tv>
- use %%global for req/prov exclude
- autoconvert to new prov/req excludes

* Sun Jul 13 2014 anaselli <anaselli> 5.0.1-1.mga5
+ Revision: 651754
- New version 5.0.1.0

* Sat Apr 26 2014 matteo <matteo> 4.2.2-1.mga5
+ Revision: 618148
- new version 4.2.2-2

* Mon Oct 21 2013 umeabot <umeabot> 4.0.12-2.mga4
+ Revision: 537939
- Mageia 4 Mass Rebuild

* Fri Sep 27 2013 anaselli <anaselli> 4.0.12-1.mga4
+ Revision: 488061
- New version 4.0.12

* Sun Jul 14 2013 matteo <matteo> 4.0.9-2.mga4
+ Revision: 454356
- rebuilt against new mono-addins 1.0

* Thu Jul 11 2013 matteo <matteo> 4.0.9-1.mga4
+ Revision: 453159
- new version 4.0.9
- updated gtk-sharp reference to version 2.12.21

* Fri Jun 07 2013 fwang <fwang> 3.0.6-2.mga4
+ Revision: 439511
- revert

* Fri Jun 07 2013 fwang <fwang> 4.0-4.mga4
+ Revision: 438830
- really put data.entity as filtered

* Fri Jun 07 2013 fwang <fwang> 4.0-3.mga4
+ Revision: 438825
- really put data.entity as filtered

* Fri Jun 07 2013 fwang <fwang> 4.0-2.mga4
+ Revision: 438820
- * add exception on system.data.entity as stated upstream:
  http://lists.ximian.com/pipermail/mono-devel-list/2012-September/039630.html

* Fri Jun 07 2013 fwang <fwang> 4.0-1.mga4
+ Revision: 438809
- new version 4.0

* Sat Jan 12 2013 umeabot <umeabot> 3.0.6-2.mga3
+ Revision: 360259
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 anaselli <anaselli> 3.0.6-1.mga3
+ Revision: 343095
- New version 3.0.6

* Sun Nov 25 2012 fwang <fwang> 3.0.5-1.mga3
+ Revision: 321802
- cleanup spec
- br rsync
- new version 3.0.5

* Tue Jul 31 2012 matteo <matteo> 3.0.3.5-1.mga3
+ Revision: 276778
- new version

* Sat Jul 21 2012 matteo <matteo> 3.0.3.4-1.mga3
+ Revision: 273077
- new version

* Thu Jul 19 2012 matteo <matteo> 3.0.3.2-3.mga3
+ Revision: 272599
- fixed monodevelop-3.0.3.2-md-gettext.patch
- spec file cleaned

* Thu Jul 19 2012 matteo <matteo> 3.0.3.2-2.mga3
+ Revision: 272586
- added patch to fix md.gettext path (used by addins -debugger-gdb and -database)
- spec file reviewed

* Thu Jul 19 2012 matteo <matteo> 3.0.3.2-1.mga3
+ Revision: 272563
- added missing br mono-nunit
- enabled git support
- md compilation exit with errors using _smp_mflags (%%make) so switching to make
- new version
- new version

* Tue Apr 10 2012 anaselli <anaselli> 2.8.8.4-1.mga2
+ Revision: 230142
- new version 2.8.8.4

* Mon Feb 20 2012 anaselli <anaselli> 2.8.6.5-1.mga2
+ Revision: 211249
- New version 2.8.6.5

* Wed Feb 08 2012 matteo <matteo> 2.8.6.4-1.mga2
+ Revision: 206422
- new stable version

* Mon Feb 06 2012 matteo <matteo> 2.8.6.3-1.mga2
+ Revision: 205250
- new stable version

* Sun Jan 08 2012 anaselli <anaselli> 2.8.5.1-1.mga2
+ Revision: 193342
- new version 2.8.5.1

* Fri Dec 23 2011 matteo <matteo> 2.8.5-1.mga2
+ Revision: 186731
- version upgrade

* Thu Dec 08 2011 anaselli <anaselli> 2.8.4.2-1.mga2
+ Revision: 178993
- New version 2.8.4.2

* Thu Nov 10 2011 anaselli <anaselli> 2.8.2-3.mga2
+ Revision: 166213
- Added missing mono-tools requirement

* Thu Nov 03 2011 anaselli <anaselli> 2.8.2-2.mga2
+ Revision: 162523
- Release bump, imported to mageia 1

* Thu Nov 03 2011 anaselli <anaselli> 2.8.2-1.mga2
+ Revision: 162084
- new version 2.8.2

* Thu Nov 03 2011 anaselli <anaselli> 2.8.1-2.mga2
+ Revision: 161910
- Obsolete deprecated plugins which are not compatible with MD 2.6

* Thu Oct 13 2011 fwang <fwang> 2.8.1-1.mga2
+ Revision: 154194
- new version 2.8.1

* Sat Sep 17 2011 fwang <fwang> 2.6.0.1-1.mga2
+ Revision: 144570
- fix desktop file
- new version 2.6.0.1

* Thu Jun 16 2011 stblack <stblack> 2.4.2-1.mga2
+ Revision: 108226
- imported package monodevelop

